
#include "row.h"

namespace usql {

    int ColNullValue::compare(ColValue * other) {
    	return other->isNull() ? 0 : -1;	// null goes to end
    }

    int ColIntegerValue::compare(ColValue * other) {
    	long r = m_integer - other->getIntValue();
    	return other->isNull() ? 1 : r > 0 ? 1 : r == 0 ? 0 : -1;
    }

    int ColDoubleValue::compare(ColValue * other) {
    	if (other->isNull()) return 1;	// null goes to end

    	double c = m_double - other->getDoubleValue();
    	return c < 0 ? -1 : c == 0.0 ? 0 : 1;
    }

    int ColStringValue::compare(ColValue * other) {
    	return other->isNull() ? 1 : m_string.compare(other->getStringValue());	// null goes to end
    }

    int ColDateValue::compare(ColValue * other) {
	long r = m_date - other->getIntValue();
	return other->isNull() ? 1 : r > 0 ? 1 : r == 0 ? 0 : -1;
    }

    int ColBooleanValue::compare(ColValue * other) {
	if (other->isNull()) return 1;	// null goes to end

	return m_bool==other->getBoolValue() ? 0 : m_bool && !other->getBoolValue() ? -1 : 1;	// true first
    }

    Row::Row(int cols_count) {
	    m_columns.reserve(cols_count);
	    for (int i = 0; i < cols_count; i++) {
	    	m_columns.push_back(std::make_unique<ColNullValue>());
	    }
    }

    Row::Row(const Row &other) {
	    m_columns.reserve(other.m_columns.size());
	    // PERF here we first set cols null and then immediately replace it
	    for (int i = 0; i < other.m_columns.size(); i++) {
		    m_columns.emplace_back(std::make_unique<ColNullValue>());
	    }

	    for (int i = 0; i < other.m_columns.size(); i++) {
		if (other.m_columns[i]->isNull())
			continue;	// for null NOP

	    	ColumnType col_type = other.m_columns[i]->getColType();
	    	switch (col_type)  {
			case ColumnType::integer_type :
				setIntColumnValue(i, (static_cast<ColIntegerValue *>(other.m_columns[i].get())->getIntValue()));
				break;
			case ColumnType::float_type :
				setFloatColumnValue(i, (static_cast<ColDoubleValue *>(other.m_columns[i].get())->getDoubleValue()));
				break;
			case ColumnType::varchar_type :
				setStringColumnValue(i, (static_cast<ColStringValue *>(other.m_columns[i].get())->getStringValue()));
				break;
			case ColumnType::date_type :
				setDateColumnValue(i, (static_cast<ColDateValue *>(other.m_columns[i].get())->getDateValue()));
				break;
			case ColumnType::bool_type :
				setBoolColumnValue(i, (static_cast<ColBooleanValue *>(other.m_columns[i].get())->getBoolValue()));
	    			break;
			default:
	    			throw Exception("unsupported column type");
		}
	    }
    }


    Row &Row::operator=(Row other) {
	    std::swap(m_columns, other.m_columns);
	    return *this;
    }

    void Row::setColumnNull(int col_index) {
	m_columns[col_index] = std::make_unique<ColNullValue>();
    }

    void Row::setIntColumnValue(int col_index, long value) {
	    m_columns[col_index] = std::make_unique<ColIntegerValue>(value);
    }

    void Row::setFloatColumnValue(int col_index, double value) {
	    m_columns[col_index] = std::make_unique<ColDoubleValue>(value);
    }

    void Row::setStringColumnValue(int col_index, const std::string &value) {
	    m_columns[col_index] = std::make_unique<ColStringValue>(value);
    }

    void Row::setDateColumnValue(int col_index, long value) {
    	m_columns[col_index] = std::make_unique<ColDateValue>(value);
    }

    void Row::setDateColumnValue(int col_index, const std::string &value) {
	m_columns[col_index] = std::make_unique<ColDateValue>(Settings::string_to_date(value));
    }

    void Row::setBoolColumnValue(int col_index, bool value) {
    	m_columns[col_index] = std::make_unique<ColBooleanValue>(value);
    }

    void Row::setBoolColumnValue(int col_index, const std::string &value) {
    	bool v = (value=="Y" || value=="1");
    	m_columns[col_index] = std::make_unique<ColBooleanValue>(v);
    }

    void Row::setColumnValue(ColDefNode *col_def, ColValue *col_value) {
	if (!col_value->isNull()) {
		if (col_def->type == ColumnType::integer_type)
			setIntColumnValue(col_def->order, col_value->getIntValue());
		else if (col_def->type == ColumnType::float_type)
			setFloatColumnValue(col_def->order, col_value->getDoubleValue());
		else if (col_def->type == ColumnType::varchar_type)
			setStringColumnValue(col_def->order, col_value->getStringValue());
		else if (col_def->type == ColumnType::date_type)
			setDateColumnValue(col_def->order, col_value->getDateValue());
		else if (col_def->type == ColumnType::bool_type)
			setBoolColumnValue(col_def->order, col_value->getBoolValue());
	} else {
		setColumnNull(col_def->order);
	}
    }

void Row::setColumnValue(ColDefNode *col_def, ValueNode *col_value) {
	if (!col_value->isNull()) {
		if (col_def->type == ColumnType::integer_type)
			setIntColumnValue(col_def->order, col_value->getIntegerValue());
		else if (col_def->type == ColumnType::float_type)
			setFloatColumnValue(col_def->order, col_value->getDoubleValue());
		else if (col_def->type == ColumnType::varchar_type)
			setStringColumnValue(col_def->order, col_value->getStringValue());
		else if (col_def->type == ColumnType::date_type)
			setIntColumnValue(col_def->order, col_value->getDateValue());
		else if (col_def->type == ColumnType::bool_type)
			setBoolColumnValue(col_def->order, col_value->getBooleanValue());
		else
			throw Exception("unsupported data type");
	} else {
		setColumnNull(col_def->order);
	}
}

    int Row::compare(const Row & other) const {
	    for (int ci = 0; ci < m_columns.size(); ci++) {
		    int cmp = m_columns[ci]->compare(other.ith_column(ci));
		    if (cmp != 0) return cmp;
	    }
	    return 0;
    }

    void Row::print(const std::vector<int> & col_char_sizes) {
	    std::string out{"| "};

	    for (int ci = 0; ci < m_columns.size(); ci++) {
		auto value = m_columns[ci]->getStringValue();

	 	// TODO use rpad string function handle len
		out.append(value + std::string(col_char_sizes[ci] - value.size(), ' ') + " | ");
	    }

	    std::cout << out << std::endl;
    }

}